program DCallyDemo;

// Delphi 6PE port of Cal3D (C) 2001 Paul TOTH <tothpaul@free.fr>
// Kylix  1  port of DCal3D (C) 2001 Paul TOTH
// Cal3D-0.6 (4. Aug. 2001) (C) 2001 Bruno 'Beosil' Heidelberger

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{$apptype console}

{-$define debug}

uses
{$ifdef win32}
  Windows,
  SysUtils,
  Classes,
{$endif}
  DCal3D,
{$ifdef win32}
  DelphiGL,
{$else}
  KylixGL,
{$endif}
  Menu in 'Menu.pas',
  Demo in 'Demo.pas',
  Model in 'Model.pas';

{$R *.res}

Var
 argc:integer;


procedure idleFunc; cdecl;
 begin
 {$ifdef debug}writeln(#174'idleFunc'#175);{$endif}
  TheDemo.OnIdle;
 end;

procedure mouseFunc(button,state,x,y:integer); cdecl;
 begin
 {$ifdef debug}writeln(#174'mouseFunc'#175);{$endif}
  // redirect the message to the demo instance
  if (state = GLUT_DOWN) then begin
    theDemo.onMouseButtonDown(button, x, theDemo.Height - y - 1);
  end
  else if (state = GLUT_UP) then begin
    theDemo.onMouseButtonUp(button, x, theDemo.Height - y - 1);
  end;
end;

procedure motionFunc(x,y:integer); cdecl;
 begin
 {$ifdef debug}writeln(#174'motionFunc'#175);{$endif}
  // redirect the message to the demo instance
  theDemo.onMouseMove(x, theDemo.Height - y - 1);
 end;

procedure reshapeFunc(width, height:integer); cdecl;
 begin
 {$ifdef debug}writeln(#174'reshapeFunc'#175);{$endif}
  // set the new width/height values
  theDemo.setDimension(width, height);
 end;

procedure displayFunc; cdecl;
 begin
 {$ifdef debug}writeln(#174'displayFunc'#175);{$endif}
  // render the scene
  theDemo.onRender;
 end;

procedure keyboardFunc(key:char; x,y:integer); cdecl;
 begin
 {$ifdef debug}writeln(#174'keyboardFunc'#175);{$endif}
  // redirect the message to the demo instance
  theDemo.onKey(key, x, theDemo.Height - y - 1);
 end;


{$ifdef win32}

begin
  // initialize the GLUT system
  argc:=ParamCount+1;
  glutInit(argc,CmdLine);
{$else}
var
 i:integer;
 s:string;
 p:pchar;
begin
 for i:=0 to ParamCount do s:=s+ParamStr(i)+' ';
 i:=ParamCount+1; p:=pchar(s);
 glutInit(i,p);
{$endif}
  // create our demo instance
  TheDemo:=TDemo.Create;

  // register our own exit callback
 // atexit(exitFunc);

  // set all GLUT modes
  glutInitDisplayMode(GLUT_DOUBLE or GLUT_RGB or GLUT_DEPTH);
  glutInitWindowSize(theDemo.Width, theDemo.Height);
  glutCreateWindow('- Cal3D The Cally Demo -');
  if (theDemo.Fullscreen) then glutFullScreen;
  glutSetCursor(GLUT_CURSOR_NONE);

  // register all GLUT callback functions
  glutIdleFunc(@idleFunc);
  glutMouseFunc(@mouseFunc);
  glutMotionFunc(@motionFunc);
  glutPassiveMotionFunc(@motionFunc);
  glutReshapeFunc(@reshapeFunc);
  glutDisplayFunc(@displayFunc);
  glutKeyboardFunc(@keyboardFunc);

  // initialize our demo instance
  if(theDemo.onInit=false) then begin
    writeln('Initialization of the demo failed.');
    halt;
  end;

  // run the GLUT message loop
  glutMainLoop();

end.
